package com.zd.laboratory.service;

import com.zd.laboratory.domain.LabRiskPlanAbnormalLog;
import com.zd.laboratory.domain.SubDiyAppVO;
import com.zd.laboratory.domain.vo.LabRiskPlanAbnormalLogVO;

import java.util.List;
import java.util.Map;

/**
 * 风险异常日志Service接口
 *
 * @author liubo
 * @date 2021-09-06
 */
public interface ILabRiskPlanAbnormalLogService {
    /**
     * 查询风险异常日志
     *
     * @param id 风险异常日志主键
     * @return 风险异常日志
     */
    public LabRiskPlanAbnormalLog selectLabRiskPlanAbnormalLogById(Long id);

    /**
     * 根据预案id和组级id查询风险异常日志列表排序
     *
     * @param labRiskPlanAbnormalLog 风险异常日志
     * @return 风险异常日志集合
     */
    public List<LabRiskPlanAbnormalLog> selectLabRiskPlanAbnormalLogOrderByList(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    /**
     * 查询风险异常日志列表
     *
     * @param labRiskPlanAbnormalLog 风险异常日志
     * @return 风险异常日志集合
     */
    public List<LabRiskPlanAbnormalLog> selectLabRiskPlanAbnormalLogList(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    /**
     * 新增风险异常日志
     *
     * @param labRiskPlanAbnormalLog 风险异常日志
     * @return 结果
     */
    public int insertLabRiskPlanAbnormalLog(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    /**
     * 修改风险异常日志
     *
     * @param labRiskPlanAbnormalLog 风险异常日志
     * @return 结果
     */
    public int updateLabRiskPlanAbnormalLog(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    /**
     * 批量删除风险异常日志
     *
     * @param ids 需要删除的风险异常日志主键集合
     * @return 结果
     */
    public int deleteLabRiskPlanAbnormalLogByIds(Long[] ids);

    /**
     * 删除风险异常日志信息
     *
     * @param id 风险异常日志主键
     * @return 结果
     */
    public int deleteLabRiskPlanAbnormalLogById(Long id);

    List<Map<String, Object>> queryLineChart(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    Map<String, List<Map<String, Object>>> queryHappenChart(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    Map<String, List<Map<String, Object>>> queryStatisticsChartDept(LabRiskPlanAbnormalLog labRiskPlanAbnormalLog);

    int queryPlanCount();

    Map<String, Map<String, List<Map<String, Object>>>> queryRiskTrend(Map<String, Object> params);


    /**
     * 小程序查询当前发生的实验室风险异常日志列表
     *
     * @param labRiskPlanAbnormalLogVo 风险异常日志
     * @return 风险异常日志集合
     */
    public List<SubDiyAppVO> selectLabRiskPlanAppList(LabRiskPlanAbnormalLogVO labRiskPlanAbnormalLogVo);

    /**
     * 小程序查询当前发生的实验室风险异常日志统计
     *
     * @param labRiskPlanAbnormalLogVo 风险异常日志
     * @return 风险异常日志集合
     */
    public Map<String,Integer> selectLabRiskPlanAppCount(LabRiskPlanAbnormalLogVO labRiskPlanAbnormalLogVo);

    /**
     * 小程序查询登录人管理实验室下的预案记录列表
     *
     * @param labRiskPlanAbnormalLogVo 风险异常日志
     * @return 风险异常日志集合
     */
    public List<SubDiyAppVO> adminSubByRiskPlan(LabRiskPlanAbnormalLogVO labRiskPlanAbnormalLogVo);
}
